# SdFat: ArduinoSdFat/libraries/SdFat/src/SpiDriver/SdSpiDriver.h File Reference

SdSpiDriver.h File Reference

SpiDriver classes. More...

`#include "../common/SysCall.h"`
`#include "SPI.h"`
`#include "SdSpiArduinoDriver.h"`
Include dependency graph for SdSpiDriver.h:
This graph shows which files directly or indirectly include this file:

## Classes

class | SdSpiConfig
| SPI card configuration. More...

## Macros

#define | DEDICATED_SPI 0X80
#define | SD_SCK_HZ(maxSpeed) (maxSpeed)
#define | SD_SCK_MHZ(maxMhz) (1000000UL*(maxMhz))
#define | SHARED_SPI 0
#define | SPI_DIV3_SPEED SD_SCK_HZ(F_CPU/3)
#define | SPI_DIV6_SPEED SD_SCK_HZ(F_CPU/6)
#define | SPI_EIGHTH_SPEED SD_SCK_HZ(F_CPU/16)
#define | SPI_FULL_SPEED SD_SCK_MHZ(50)
#define | SPI_HALF_SPEED SD_SCK_HZ(F_CPU/4)
#define | SPI_QUARTER_SPEED SD_SCK_HZ(F_CPU/8)
#define | SPI_SIXTEENTH_SPEED SD_SCK_HZ(F_CPU/32)

## Typedefs

typedef SPIClass | SpiPort_t

## Functions

void | sdCsInit (SdCsPin_t pin)
void | sdCsWrite (SdCsPin_t pin, bool level)

## Detailed Description

SpiDriver classes.

Copyright (c) 2011-2019 Bill Greiman This file is part of the SdFat library for SD memory cards.

MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## Macro Definition Documentation

## DEDICATED_SPI

#define DEDICATED_SPI 0X80

The SD is the only device on the SPI bus.

## SD_SCK_HZ

#define SD_SCK_HZ | ( |  | maxSpeed | ) | (maxSpeed)

SPISettings for SCK frequency in Hz.

## SD_SCK_MHZ

#define SD_SCK_MHZ | ( |  | maxMhz | ) | (1000000UL*(maxMhz))

SPISettings for SCK frequency in MHz.

## SHARED_SPI

#define SHARED_SPI 0

SPI bus is share with other devices.

## SPI_DIV3_SPEED

#define SPI_DIV3_SPEED SD_SCK_HZ(F_CPU/3)

Set SCK rate to F_CPU/3 for Due

## SPI_DIV6_SPEED

#define SPI_DIV6_SPEED SD_SCK_HZ(F_CPU/6)

Set SCK rate to F_CPU/6 for Due

## SPI_EIGHTH_SPEED

#define SPI_EIGHTH_SPEED SD_SCK_HZ(F_CPU/16)

Set SCK rate to F_CPU/16.

## SPI_FULL_SPEED

#define SPI_FULL_SPEED SD_SCK_MHZ(50)

Set SCK to max rate.

## SPI_HALF_SPEED

#define SPI_HALF_SPEED SD_SCK_HZ(F_CPU/4)

Set SCK rate to F_CPU/4.

## SPI_QUARTER_SPEED

#define SPI_QUARTER_SPEED SD_SCK_HZ(F_CPU/8)

Set SCK rate to F_CPU/8.

## SPI_SIXTEENTH_SPEED

#define SPI_SIXTEENTH_SPEED SD_SCK_HZ(F_CPU/32)

Set SCK rate to F_CPU/32.

## Typedef Documentation

## SpiPort_t

typedef SPIClass SpiPort_t

Port type for SPI hardware driver.

## Function Documentation

## sdCsInit()

void sdCsInit | ( | SdCsPin_t | pin | ) |

Initialize SD chip select pin.

Parameters

  [in] | pin | SD card chip select pin.

Copyright (c) 2011-2019 Bill Greiman This file is part of the SdFat library for SD memory cards.

MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## sdCsWrite()

void sdCsWrite | ( | SdCsPin_t | pin,
|  | bool | level
| ) |  |

Initialize SD chip select pin.

Parameters

  [in] | pin | SD card chip select pin.
  [in] | level | SD card chip select level.